## hare 0.24.2

=== Makefile ===
.POSIX:

all:

include config.mk
include makefiles/$(PLATFORM).$(ARCH).mk

all: $(BINOUT)/hare $(BINOUT)/haredoc docs

HARE_DEFINES = \
	-D PLATFORM:str='"$(PLATFORM)"' \
	-D ARCH:str='"$(ARCH)"' \
	-D VERSION:str="\"$(VERSION)\"" \
	-D HAREPATH:str='"$(HAREPATH)"' \
	-D AARCH64_AS:str='"$(AARCH64_AS)"' \
	-D AARCH64_CC:str='"$(AARCH64_CC)"' \
	-D AARCH64_LD:str='"$(AARCH64_LD)"' \
	-D RISCV64_AS:str='"$(RISCV64_AS)"' \
	-D RISCV64_CC:str='"$(RISCV64_CC)"' \
	-D RISCV64_LD:str='"$(RISCV64_LD)"' \
	-D X86_64_AS:str='"$(X86_64_AS)"' \
	-D X86_64_CC:str='"$(X86_64_CC)"' \
	-D X86_64_LD:str='"$(X86_64_LD)"'

.SUFFIXES:
.SUFFIXES: .ha .ssa .td .s .o .scd
.ssa.td:
	@cmp -s '$@' '$@.tmp' 2>/dev/null || cp '$@.tmp' '$@'

.ssa.s:
	@printf 'QBE\t%s\n' '$@'
	@$(QBE) $(QBEFLAGS) -o '$@' '$<'

.s.o:
	@printf 'AS\t%s\n' '$@'
	@$(AS) $(ASFLAGS) -o '$@' '$<'

.scd:
	@printf 'SCDOC\t%s\n' '$@'
	@$(SCDOC) < '$<' > '$@'

$(BINOUT)/hare: $(OBJS)
	@mkdir -p -- "$(BINOUT)"
	@printf 'LD\t%s\n' "$@"
	@$(LD) $(LDLINKFLAGS) -T $(RTSCRIPT) -o $@ $(OBJS)

HARE_BUILD_ENV = HAREPATH=. HAREC="$(HAREC)" QBE="$(QBE)" AS="$(AS)" \
	LD="$(LD)" HAREFLAGS="$(HAREFLAGS)" HARECFLAGS="$(HARECFLAGS)" \
	QBEFLAGS="$(QBEFLAGS)" ASFLAGS="$(ASFLAGS)" LDLINKFLAGS="$(LDLINKFLAGS)"

$(BINOUT)/haredoc: $(BINOUT)/hare
	@mkdir -p $(BINOUT)
	@printf 'HARE\t%s\n' "$@"
	@env $(HARE_BUILD_ENV) \
		$(BINOUT)/hare build $(HARE_DEFINES) -o $(BINOUT)/haredoc ./cmd/haredoc

docs/html: $(BINOUT)/haredoc
	mkdir -p docs/html
	$(BINOUT)/haredoc -Fhtml > docs/html/index.html
	for d in $$(scripts/moddirs); do \
		find $$d -type d | sed -E '/(\+|-)/d'; \
	done \
	| while read path; do \
		mod=$$(echo $$path | sed -E 's@/@::@g'); \
		echo $$mod; \
		mkdir -p docs/html/$$path; \
		$(BINOUT)/haredoc -Fhtml $$mod > docs/html/$$path/index.html; \
	done

docs: \
	docs/hare.1 \
	docs/hare-build.1 \
	docs/hare-cache.1 \
	docs/hare-deps.1 \
	docs/haredoc.1 \
	docs/hare-run.1 \
	docs/hare-test.1 \
	docs/haredoc.5 \
	docs/hare-module.5

MAN1 = hare hare-build hare-cache hare-deps haredoc hare-run hare-test
MAN5 = haredoc hare-module

bootstrap:
	@BINOUT=$(BINOUT) ./scripts/genbootstrap

clean:
	rm -rf -- '$(HARECACHE)' '$(BINOUT)' docs/*.1 docs/*.5 docs/html

check: $(BINOUT)/hare
	@env HAREPATH=. HAREC='$(HAREC)' QBE='$(QBE)' AS='$(AS)' LD='$(LD)' \
		HAREFLAGS='$(HAREFLAGS)' HARECFLAGS='$(HARECFLAGS)' \
		QBEFLAGS='$(QBEFLAGS)' ASFLAGS='$(ASFLAGS)' \
		LDLINKFLAGS='$(LDLINKFLAGS)' '$(BINOUT)/hare' test

install: install-cmd install-mods

install-cmd:
	mkdir -p -- \
		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man1' \
		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man5'
	install -m755 '$(BINOUT)/hare' '$(DESTDIR)$(BINDIR)/hare'
	install -m755 '$(BINOUT)/haredoc' '$(DESTDIR)$(BINDIR)/haredoc'
	for i in $(MAN1); do install -m644 docs/$$i.1 '$(DESTDIR)$(MANDIR)'/man1/$$i.1; done
	for i in $(MAN5); do install -m644 docs/$$i.5 '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done

install-mods:
	rm -rf -- '$(DESTDIR)$(STDLIB)'
	mkdir -p -- '$(DESTDIR)$(STDLIB)'
	cp -R -- $$(scripts/moddirs) '$(DESTDIR)$(STDLIB)'

uninstall:
	rm -- '$(DESTDIR)$(BINDIR)/hare'
	rm -- '$(DESTDIR)$(BINDIR)/haredoc'
	for i in $(MAN1); do rm -- '$(DESTDIR)$(MANDIR)'/man1/$$i.1; done
	for i in $(MAN5); do rm -- '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done
	rm -r -- '$(DESTDIR)$(STDLIB)'

.PHONY: all $(BINOUT)/haredoc bootstrap clean check docs \
	docs/html install start uninstall

=== debian/changelog ===
hare (0.24.2-4) unstable; urgency=medium

  [ Guilherme Puida Moreira ]
  * Skip non-native autopkgtests on riscv64.

 -- Miguel Landaeta <nomadium@debian.org>  Thu, 27 Mar 2025 20:14:02 +0000

hare (0.24.2-3) unstable; urgency=medium

  [ Guilherme Puida Moreira ]
  * Set up autopkgtest that runs the upstream test suite.
  * Specify architectures for binary package.

  [ Antonio Terceiro ]
  * Add autopkgtest smoke tests for all supported targets.

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 09 Mar 2025 18:09:45 +0000

hare (0.24.2-2) unstable; urgency=medium

  [ Miguel Landaeta ]
  * Add B-D on tzdata. (Closes: #1098342)

  [ Tobias Heider & Antonio Terceiro ]
  * Fix build config for arch != x86_64.

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 02 Mar 2025 08:20:30 +0000

hare (0.24.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1058645)

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 13 Oct 2024 21:51:09 +0100

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export VERSION = $(DEB_VERSION)
export PREFIX = /usr
export SRCDIR = $(PREFIX)/share

%:
	dh $@

override_dh_auto_clean:
	-dh_auto_clean
	-rm -f ./config.mk

override_dh_auto_configure:
	debian/configure $(DEB_BUILD_GNU_CPU)

override_dh_auto_build:
	dh_auto_build -- VERSION=$(VERSION) SRCDIR=$(SRCDIR) PREFIX=$(PREFIX)

override_dh_auto_install:
	dh_auto_install -- SRCDIR=$(SRCDIR) PREFIX=$(PREFIX)

# disabling dh_dwz as is causing the following lintian error:
# E: hare-dbgsym: stripped-library
# [usr/lib/debug/.dwz/x86_64-linux-gnu/hare.debug]
override_dh_dwz:

=== debian/tests/control ===
Tests: upstream-tests
Depends: @, tzdata

Tests: amd64
Depends: @, qemu-user [!amd64], binutils-x86-64-linux-gnu
Restrictions: allow-stderr, superficial
Architecture: !riscv64

Tests: arm64
Depends: @, qemu-user [!arm64], binutils-aarch64-linux-gnu
Restrictions: allow-stderr, superficial
Architecture: !riscv64

Tests: riscv64
Depends: @, qemu-user [!riscv64], binutils-riscv64-linux-gnu
Restrictions: allow-stderr, superficial

## hare 0.25.2

=== Makefile ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	-D ARCH:str='"$(ARCH)"' \
 	-D VERSION:str="\"$(VERSION)\"" \
 	-D HAREPATH:str='"$(HAREPATH)"' \
+	-D TOOLDIR:str='"$(TOOLDIR)"' \
 	-D AARCH64_AS:str='"$(AARCH64_AS)"' \
 	-D AARCH64_CC:str='"$(AARCH64_CC)"' \
 	-D AARCH64_LD:str='"$(AARCH64_LD)"' \
@@ -45,14 +46,20 @@
 	@$(LD) $(LDLINKFLAGS) -T $(RTSCRIPT) -o $@ $(OBJS)
 
 HARE_BUILD_ENV = HAREPATH=. HAREC="$(HAREC)" QBE="$(QBE)" AS="$(AS)" \
-	LD="$(LD)" HAREFLAGS="$(HAREFLAGS)" HARECFLAGS="$(HARECFLAGS)" \
-	QBEFLAGS="$(QBEFLAGS)" ASFLAGS="$(ASFLAGS)" LDLINKFLAGS="$(LDLINKFLAGS)"
+	LD="$(LD)" HARECFLAGS="$(HARECFLAGS)" QBEFLAGS="$(QBEFLAGS)" \
+	ASFLAGS="$(ASFLAGS)" LDLINKFLAGS="$(LDLINKFLAGS)" LDFLAGS="$(LDFLAGS)"
+
+$(BINOUT)/hare-install: $(BINOUT)/hare
+	@mkdir -p $(BINOUT)
+	@printf 'HARE\t%s\n' "$@"
+	@env $(HARE_BUILD_ENV) \
+		$(BINOUT)/hare build $(HARE_DEFINES) $(HAREFLAGS) -o $@ ./cmd/hare
 
 $(BINOUT)/haredoc: $(BINOUT)/hare
 	@mkdir -p $(BINOUT)
 	@printf 'HARE\t%s\n' "$@"
-	@env $(HARE_BUILD_ENV) \
-		$(BINOUT)/hare build $(HARE_DEFINES) -o $(BINOUT)/haredoc ./cmd/haredoc
+	@env $(HARE_BUILD_ENV) $(BINOUT)/hare build \
+		$(HARE_DEFINES) $(HAREFLAGS) -o $@ ./cmd/haredoc
 
 docs/html: $(BINOUT)/haredoc
 	mkdir -p docs/html
@@ -72,6 +79,7 @@
 	docs/hare-build.1 \
 	docs/hare-cache.1 \
 	docs/hare-deps.1 \
+	docs/hare-tool.1 \
 	docs/haredoc.1 \
 	docs/hare-run.1 \
 	docs/hare-test.1 \
@@ -95,11 +103,11 @@
 
 install: install-cmd install-mods
 
-install-cmd:
+install-cmd: all $(BINOUT)/hare-install
 	mkdir -p -- \
 		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man1' \
 		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man5'
-	install -m755 '$(BINOUT)/hare' '$(DESTDIR)$(BINDIR)/hare'
+	install -m755 '$(BINOUT)/hare-install' '$(DESTDIR)$(BINDIR)/hare'
 	install -m755 '$(BINOUT)/haredoc' '$(DESTDIR)$(BINDIR)/haredoc'
 	for i in $(MAN1); do install -m644 docs/$$i.1 '$(DESTDIR)$(MANDIR)'/man1/$$i.1; done
 	for i in $(MAN5); do install -m644 docs/$$i.5 '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done
@@ -116,5 +124,5 @@
 	for i in $(MAN5); do rm -- '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done
 	rm -r -- '$(DESTDIR)$(STDLIB)'
 
-.PHONY: all $(BINOUT)/haredoc bootstrap clean check docs \
-	docs/html install start uninstall
+.PHONY: all $(BINOUT)/hare-install $(BINOUT)/haredoc bootstrap clean check \
+	docs docs/html install start uninstall

=== debian/changelog ===
hare (0.25.2-1) unstable; urgency=medium

  * d/control:
    - Move package to the Debian Hare Team.
    - Specify version synchronization between hare and harec.
    - Use my @debian.org mail address.
    - Bump Standards-Version to 4.7.2, no changes needed.
  * d/s/lintian-overrides: Silence version-substvar-for-external-package.
  * d/{control,t/control}: Apply wrap-and-sort -ast.
  * d/{configure,rules}: Move upstream version handling to configure script.

 -- Guilherme Puida Moreira <puida@debian.org>  Thu, 11 Sep 2025 21:20:14 -0300

=== debian/control ===
Source: hare
Section: devel
Priority: optional
Maintainer: Debian Hare Team <team+pkg-hare@tracker.debian.org>
Uploaders:
 Miguel Landaeta <nomadium@debian.org>,
 Guilherme Puida Moreira <puida@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 harec,
 scdoc <!nodoc>,
 tzdata <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://harelang.org/
Vcs-Browser: https://salsa.debian.org/hare-team/pkg/hare
Vcs-Git: https://salsa.debian.org/hare-team/pkg/hare.git

Package: hare
Architecture: amd64 arm64 riscv64
Depends:
 harec (>> ${source:Upstream-Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Simple, stable and robust systems programming language
 Hare uses a static type system, manual memory management, and a minimal
 runtime. It is well-suited to writing operating systems, system tools,
 compilers, networking software, and other low-level, high performance tasks.
 .
 This package installs the Hare standard library and build driver.

=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,10 @@
 	-rm -f ./config.mk
 
 override_dh_auto_configure:
-	debian/configure $(DEB_BUILD_GNU_CPU)
+	debian/configure $(DEB_BUILD_GNU_CPU) $(VERSION)
 
 override_dh_auto_build:
-	dh_auto_build -- VERSION=$(VERSION) SRCDIR=$(SRCDIR) PREFIX=$(PREFIX)
+	dh_auto_build -- SRCDIR=$(SRCDIR) PREFIX=$(PREFIX)
 
 override_dh_auto_install:
 	dh_auto_install -- SRCDIR=$(SRCDIR) PREFIX=$(PREFIX)

=== debian/tests/control ===
Tests:
 upstream-tests,
Depends:
 tzdata,
 @,

Tests:
 amd64,
Depends:
 binutils-x86-64-linux-gnu,
 qemu-user [!amd64],
 @,
Restrictions:
 allow-stderr,
 superficial,
Architecture: !riscv64

Tests:
 arm64,
Depends:
 binutils-aarch64-linux-gnu,
 qemu-user [!arm64],
 @,
Restrictions:
 allow-stderr,
 superficial,
Architecture: !riscv64

Tests:
 riscv64,
Depends:
 binutils-riscv64-linux-gnu,
 qemu-user [!riscv64],
 @,
Restrictions:
 allow-stderr,
 superficial,

## hare 0.26.0

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 include config.mk
 include makefiles/$(PLATFORM).$(ARCH).mk
 
-all: $(BINOUT)/hare $(BINOUT)/haredoc docs
+all: $(BINOUT)/hare-configured $(BINOUT)/haredoc docs
 
 HARE_DEFINES = \
 	-D PLATFORM:str='"$(PLATFORM)"' \
@@ -40,6 +40,7 @@
 	@printf 'SCDOC\t%s\n' '$@'
 	@$(SCDOC) < '$<' > '$@'
 
+# bootstrapped hare(1), without HARE_DEFINES configuration
 $(BINOUT)/hare: $(OBJS)
 	@mkdir -p -- "$(BINOUT)"
 	@printf 'LD\t%s\n' "$@"
@@ -49,7 +50,8 @@
 	LD="$(LD)" HARECFLAGS="$(HARECFLAGS)" QBEFLAGS="$(QBEFLAGS)" \
 	ASFLAGS="$(ASFLAGS)" LDLINKFLAGS="$(LDLINKFLAGS)" LDFLAGS="$(LDFLAGS)"
 
-$(BINOUT)/hare-install: $(BINOUT)/hare
+# hare(1) configured with HARE_DEFINES configuration
+$(BINOUT)/hare-configured: $(BINOUT)/hare
 	@mkdir -p $(BINOUT)
 	@printf 'HARE\t%s\n' "$@"
 	@env $(HARE_BUILD_ENV) \
@@ -86,7 +88,7 @@
 	docs/haredoc.5 \
 	docs/hare-module.5
 
-MAN1 = hare hare-build hare-cache hare-deps haredoc hare-run hare-test
+MAN1 = hare hare-build hare-cache hare-deps haredoc hare-run hare-test hare-tool
 MAN5 = haredoc hare-module
 
 bootstrap:
@@ -103,11 +105,11 @@
 
 install: install-cmd install-mods
 
-install-cmd: all $(BINOUT)/hare-install
+install-cmd: all $(BINOUT)/hare-configured
 	mkdir -p -- \
 		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man1' \
 		'$(DESTDIR)$(BINDIR)' '$(DESTDIR)$(MANDIR)/man5'
-	install -m755 '$(BINOUT)/hare-install' '$(DESTDIR)$(BINDIR)/hare'
+	install -m755 '$(BINOUT)/hare-configured' '$(DESTDIR)$(BINDIR)/hare'
 	install -m755 '$(BINOUT)/haredoc' '$(DESTDIR)$(BINDIR)/haredoc'
 	for i in $(MAN1); do install -m644 docs/$$i.1 '$(DESTDIR)$(MANDIR)'/man1/$$i.1; done
 	for i in $(MAN5); do install -m644 docs/$$i.5 '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done
@@ -115,7 +117,7 @@
 install-mods:
 	rm -rf -- '$(DESTDIR)$(STDLIB)'
 	mkdir -p -- '$(DESTDIR)$(STDLIB)'
-	cp -R -- $$(scripts/moddirs) '$(DESTDIR)$(STDLIB)'
+	cp -R -- $$(scripts/moddirs) README '$(DESTDIR)$(STDLIB)'
 
 uninstall:
 	rm -- '$(DESTDIR)$(BINDIR)/hare'
@@ -124,5 +126,5 @@
 	for i in $(MAN5); do rm -- '$(DESTDIR)$(MANDIR)'/man5/$$i.5; done
 	rm -r -- '$(DESTDIR)$(STDLIB)'
 
-.PHONY: all $(BINOUT)/hare-install $(BINOUT)/haredoc bootstrap clean check \
+.PHONY: all $(BINOUT)/hare-configured $(BINOUT)/haredoc bootstrap clean check \
 	docs docs/html install start uninstall

=== debian/changelog ===
hare (0.26.0-1) unstable; urgency=medium

  * New upstream release 0.26.0.
  * d/u/metadata: Create file and add Repository/Repository-Browse.
  * d/gbp.conf: Add upstream-vcs-tag.
  * d/control: Bump Standards-Version to 4.7.3. Consequently:
    - d/control: Drop Rules-Require-Root field.
  * d/control: Drop optional Priority field.
  * d/watch: Update to version 5.

 -- Guilherme Puida Moreira <puida@debian.org>  Fri, 13 Feb 2026 22:09:52 -0300

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: hare
 Section: devel
-Priority: optional
 Maintainer: Debian Hare Team <team+pkg-hare@tracker.debian.org>
 Uploaders:
  Miguel Landaeta <nomadium@debian.org>,
  Guilherme Puida Moreira <puida@debian.org>,
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  harec,
  scdoc <!nodoc>,
  tzdata <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://harelang.org/
 Vcs-Browser: https://salsa.debian.org/hare-team/pkg/hare
 Vcs-Git: https://salsa.debian.org/hare-team/pkg/hare.git

=== debian/watch ===
Version: 5
Source: https://git.sr.ht/~sircmpwn/hare/refs
Matching-Pattern: .*/@SEMANTIC_VERSION@@ARCHIVE_EXT@
Uversion-Mangle: auto
